using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;
using System.Runtime.InteropServices;

namespace MyTrimmer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.listView1.Columns.Add(new ColumnHeader());
            this.listView1.Columns.Add(new ColumnHeader());
            this.listView1.Columns.Add(new ColumnHeader());

            this.listView1.Columns[0].Text = "Process Name";
            this.listView1.Columns[1].Text = "Working Set";
            this.listView1.Columns[2].Text = "Virtual Memory";

            this.listView1.Columns[0].TextAlign = HorizontalAlignment.Left;
            this.listView1.Columns[1].TextAlign = HorizontalAlignment.Right;
            this.listView1.Columns[2].TextAlign = HorizontalAlignment.Right;

            this.listView1.ColumnClick += delegate(object o, ColumnClickEventArgs e)
                {
                    // Set the ListViewItemSorter property to a new ListViewItemComparer 
                    // object. Setting this property immediately sorts the 
                    // ListView using the ListViewItemComparer object.
                    this.listView1.ListViewItemSorter = new ListViewItemComparer(e.Column);
                };

            this.listView1.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize);

        }
        // Implements the manual sorting of items by columns.
        /// <seealso cref="http://msdn2.microsoft.com/ja-jp/library/system.windows.forms.listview.listviewitemsorter.aspx"/>
        class ListViewItemComparer : System.Collections.IComparer
        {
            private int col;
            public ListViewItemComparer()
            {
                col = 0;
            }
            public ListViewItemComparer(int column)
            {
                col = column;
            }
            public int Compare(object x, object y)
            {
                Process p1 = (x as ListViewItem).Tag as Process;
                Process p2 = (y as ListViewItem).Tag as Process;
                switch (col)
                {
                    case 0:
                        return Comparer<string>.Default.Compare(p1.ProcessName, p2.ProcessName);
                    case 1:
                        return Comparer<long>.Default.Compare(p1.WorkingSet64, p2.WorkingSet64);
                    case 2:
                        return Comparer<long>.Default.Compare(p1.VirtualMemorySize64, p2.VirtualMemorySize64);
                    default:
                        throw new Exception("m̗ł");
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.UpdateProcesses();
        }

        [DllImport("kernel32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool SetProcessWorkingSetSize(IntPtr processHandle, IntPtr MinimumWorkingSetSize, IntPtr MaximumWorkingSetSize);

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.listView1.SelectedItems.Count > 0)
            {
                ListViewItem item = this.listView1.SelectedItems[0];
                try
                {
                    Process process = item.Tag as Process;
                    IntPtr minusOne = new IntPtr(-1L);
                    // process.MaxWorkingSet = process.MinWorkingSet = minusOne; ͎ŝAPI Ăяo
                    bool ret = true; SetProcessWorkingSetSize(process.Handle, minusOne, minusOne);
                    if (ret)
                    {
                        // Process CX^X̂̃p[^ imutable Ȃ悤Ȃ̂ō蒼
                        process = Process.GetProcessById(process.Id);
                        item.Tag = process;
                        item.SubItems[1].Text = (process.WorkingSet64 / 1024).ToString("N0") + " K";
                        item.SubItems[2].Text = (process.VirtualMemorySize64 / 1024).ToString("N0") + " K";
                        this.listView1.RedrawItems(item.Index, item.Index, false);
                    }
                    else
                    {
                        MessageBox.Show("SetProcessWorkingSetSize failed");
                    }
                }
                catch (Exception exp)
                {
                    MessageBox.Show(exp.Message);
                }
            }
        }

        private void UpdateProcesses()
        {
            ListViewItem[] items = Array.ConvertAll<Process, ListViewItem>(Process.GetProcesses(),
                 delegate(Process process)
                 {
                     ListViewItem item = new ListViewItem(new string[] { process.ProcessName, (process.WorkingSet64 / 1024).ToString("N0") + " K", (process.VirtualMemorySize64 / 1024).ToString("N0") + " K" });
                     item.Tag = process;
                     return item;
                 }
             );
            this.SuspendLayout();
            this.listView1.Items.Clear();
            this.listView1.Items.AddRange(items);
            ListViewItem topItem = this.listView1.TopItem;
            this.listView1.TopItem = topItem;
            this.ResumeLayout();
        }
    }
}